TTYNAME(3)

NAME
ttyname, isatty, ttyslot - get name of associated terminal (tty) from file descriptor

LIBRARY
libc

SYNOPSIS
#include <unistd.h>
char *
ttyname(int fd);
int
isatty(int fd);
#include <stdlib.h>
int
ttyslot();

DESCRIPTION
These functions operate on the system file descriptors for terminal type devices. These descriptors are not related to the standard I/O FILE typedef, but refer to the special device files found in /dev and named /dev/ttyxx and for which an entry exists in the initialization file /etc/ttys. (See ttys(5).)

The isatty() function determines if the file descriptor fd refers to a valid terminal type device.

The ttyname() function gets the related device name of a file descriptor for which isatty() is true.

The ttyslot() function fetches the current process' control terminal number from the ttys(5) file entry.

RETURN VALUES
The ttyname() function returns the null terminated name if the device is found and isatty() is true; otherwise a NULL pointer is returned and errno is set to indicate the error.

The isatty() function returns 1 if fd is associated with a terminal device; otherwise it returns 0 and errno is set to indicate the error.

The ttyslot() function returns the unit number of the device file if found; otherwise the value zero is returned.

ERRORS
The ttyname() and isatty() functions will fail if:

[EBADF]
    The fd argument is not a valid file descriptor.

[ENOTTY]
    The fd argument does not refer to a terminal device.

FILES
/dev/*
/etc/ttys

SEE ALSO
ioctl(2), ttys(5)

STANDARDS
The ttyname() and isatty() functions conform to p1003.1-90.

HISTORY
A isatty(), ttyname(), and ttyslot() function appeared in AT&T UNIX.

BUGS
The ttyname() function leaves its result in an internal static object and returns a pointer to that object. Subsequent calls to ttyname() will modify the same object.